mod ip; // declare that there is a ip.rs module needed by this project

use ip::Ip; // import the Ip type from the ip module
use colored::*; // for fancy colors :)

fn main() {
    let Some(arg) = std::env::args().nth(1) else {
        println!("we need one argument.");
        return;
    };

    let Some(ip) = Ip::from_str(&arg) else {
        println!("'{}' is is not a valid ipv4 address.", arg);
        return;
    };
    
    let nbr = u32::from(&ip);
    
    println!("Canonical: {}", ip.to_string().blue().bold());    
    println!("Debug....: {}", format!("{:?}", ip).green());
    println!("Binary...: {}", format!("{:032b}", nbr).red());
    println!("Hexa.....: {}", format!("0x{:x}", nbr).yellow());

    let comment = match ip {
        Ip::V4([127, 0, 0, 1]) => "This is you.",
        Ip::V4([192,168,_,_]) => "This is a local area network",
        Ip::V4([10,_,_,_]) => "This is a big local area network",
        _ => "Nothing special to say about this address"
    };
    println!("{}", comment.dimmed());

}
